// import MCUClientEngine1 from'http://192.168.1.140/McuClient/main.js'


var client;
var MessageTypes;
var canvasInfo;
var canvasInfoUpdate;
var canvasInfoArr=[];
var canvasInfoUpArr=[];

var classLoadInfo;  //3个参数 课堂号/用户角色/ip 的对象

var classAllInfo={};

var fourParams={};

var fileInfo={};  //传递给底层的对象

var fileDeleteInfo={}; //删除的文件对象

var thisFileName; //当前点击的文件名称

var thisFileId;//当前点击的文件ID

var thisDocId;
var thisClassId;

var thisFileParent;//当前元素的父级

var fileFromArr=[]; //存储底层返回的文件,放到该数组

var fileFromUpArr=[];//存储上传返回的文件,,放到该数组


var classParamInfo={}

var pdfUrl;
var docfullPath;
var imgUrl;


var switchArr=[];



var pdfFile;
var currPageNumber;

var fileShowArr=[]; //存储显示的文档

var pdfArr=[];

var openPage;

var pdfUrlArr=[];

var docfullPathArr=[];

var imgUrlSingle;



//画布
var canvas ;
var context ;
//蒙版
var canvas_bak;
var context_bak;

// 消息模板-老师
var tpl_message_teacher = `
  <div class="teacher-msg "><img class="teaImg" src="images/teacher-photo.png" alt="老师头像">
                            <p>{message}</p></div>`;

// 消息模板-学生
var tpl_message_student = `
 <div class="student-msg"><img class="stuImg" src="images/student-photo.png" alt="学生头像">
                            <p>{message}</p></div>`;
//上传文件列表模板
var tpl_doc=`<li><div class="forSwitch"><span class="iconfont">&#xe639;</span><span class="itemName">{name}</span><span class="itemIdx">{itemIdx}</span></div><span  class="deleteDoc iconfont">&#xe635;</span>
                            </li>`;

function mainTimeStamp() {
    var _teatimestamp= Date.parse(new Date());
    return _teatimestamp;
}

$(function () {




    // FastClick.attach(document.body);

    initEngine();//加载MCUClientEngine;
    loading();

    urlParamsJudge();//对地址栏参数的数据进行判断




});

function initEngine(){

    //创建客户端
    client=MCUClientEngine.createMcuClient();
    //获取事件监听消息定义
    MessageTypes=MCUClientEngine.MessageTypes;
    console.log(client.sdkInfo.version);

    videoWithFlash.flashInit(client);
    // nativeVideo.nativeInit(client);

}

//在窗口关闭前提示用户
window.onbeforeunload = function() {
    if(client){
        console.log("11111111111111111111111")
    }else {
        console.log("11111111111111111111111")
    }
    return false; // 可以阻止关闭
}
//窗口关闭,退出课堂
window.onunload=function () {
    if(client){
        client.leaveClass();
    }
}

//进入课堂初始化成功
function classInitSuccess(callbackData){
    //进入课堂初始化成功回调
    console.log("classInitSuccess---初始化成功");
    console.log(callbackData);
    if(callbackData.classType==1){
        $(".box").css("display","none");
    }else if (callbackData.classType==2){

    }
    if(callbackData){
        console.log(callbackData.passwordRequired);
        showLogin(callbackData.passwordRequired);
    }

}
//上传文件
function importFile() {
    console.log("上传文件");
    console.log(classAllInfo);
    var selectedFile =document.getElementById("file").files[0];//获取读取的File对象
    console.log(document.getElementById("file").files);
    var name = selectedFile.name;//读取选中文件的文件名
    var size = selectedFile.size;//读取选中文件的大小
    var mime = selectedFile.type;
    console.log("文件名:" + name + "大小：" + size+"文件类型:"+mime);



    var fd = new FormData();
    fd.append("fileToUpload", document.getElementById('file').files[0]);
    fd.append("siteID",classAllInfo.siteId);   //站点
    fd.append("convertTools","msoffice");  //pptflash 仅限动态转ppt    msoffice 其它类型
    fd.append("meetingid",String(classAllInfo.classId));  //课堂号
    fd.append("timestamp",String(mainTimeStamp()));  //时间戳
    fd.append("createUserName",String(classAllInfo.userName));  //上传人姓名
    fd.append("createUserID",String(classAllInfo.nodeId));   //上传人ID
    fd.append("modifyDate","2015-09-14 18:22:22");  //上传时间

    $.ajax({
        type:"POST",
        url:"http://101.200.150.192:80/DocSharing/fileUploadJson",
        processData: false,
        contentType: false,
        data:fd,
        success: function(data) {
            console.log("文档服务器返回的",data);
            uploadFile(data);
        },
        error: function(data){
            console.log(data)
        }
    });


}

//删除文件
function deleteFile(msg) {

    console.log("要删除的文档编号");
    console.log(msg);
    console.log("此时文档都有什么");
    console.log(fileFromArr);
    client.sendDocumentDelete(msg);

}

//显示当前课堂文件列表中文件
function showFile(_data){


    var tplDoc=tpl_doc;
    for (var i=0;i<_data.length;i++){

        var strHTML = format(tplDoc, {
            name: _data[i].fileName,
            itemIdx:_data[i].itemIdx
        });

    }

    // var strHTML = format(tplDoc, {
    //     name: _data.fileName,
    //     itemIdx:_data.itemIdx
    // });


    $("#fileUl").append(strHTML);

    console.log("当前文档存储是什么=================");
    console.log(fileFromArr);

        //删除文档
    $(".deleteDoc").click(function (e) {

        $(this).parent().addClass("xin");
        // thisFileName=$(".forSwitch").children(".itemName").html()
        thisFileName=$(this).parent().find(".itemName").html()
        console.log(thisFileName,"==================");
        for (var i=0; i<fileFromArr.length;i++ ){

                    console.log("i值是多少====================",i);
                    console.log(fileFromArr[i]);
                    var ArrName=fileFromArr[i].fileName;
                    console.log(ArrName);
                    var _paramInfo={};
                    if (thisFileName==ArrName){
                        thisFileId=fileFromArr[i].itemIdx;
                        thisClassId=classAllInfo.classId;
                        thisDocId=fileFromArr[i].docId;

                        _paramInfo.itemIdx=thisFileId;
                        _paramInfo.docId=thisDocId;
                        _paramInfo.classId=thisClassId;

                        console.log(thisFileId,thisClassId,thisDocId);
                        deleteFile(_paramInfo);


                       }
        }


    });



//切换文档
    var oUl=document.getElementById("fileUl");
    var oLi=oUl.getElementsByTagName("li");
    var oLis=oUl.getElementsByTagName("div");
    for(var i=0;i<oLis.length;i++){
        oLis[i].onclick=function(){

            var itemID=$(this).children(".itemIdx").html();
                console.log(itemID);
                console.log("切换文档======================");
                switchDoc(itemID);

        }
    }

}




//切换文档
function switchDoc(msg) {
    var paramInfo={
        "itemIdx": msg,
        "visible":true
    };
    client.sendDocumentSwitchDoc(paramInfo);
    console.log("此时数组中存储的数=====",fileFromArr);


}



//将上传文件的信息,传递给底层
function uploadFile(msg){
    console.log("服务器返回的文件信息");
    console.log(msg);
    // fileInfo.fileName=msg.fileName;//文档名字
    fileInfo.pageNum=msg.imgSize;// 文档的总页数
    fileInfo.fileName=msg.fileName;//文档名字
    fileInfo.fileType=msg.fileType;  // 文档的原始类型(上传时的类型)
    fileInfo.relativeUrl=msg.relativeLocation;   //文档相对地址
    fileInfo.url=msg.filePath;   //文档绝对地址  默认值: null
    fileInfo.docId=msg.docId;    //文档在数据库中的唯一id标识 默认值: null
     fileInfo.visible=false;    // 是否显示  默认值: false
    fileInfo.dynamicTS=msg.dynamicTransferStatic   //是否动态转换 //文档上传后返回值中的字段dynamicTransferStatic  默认值: 0

    console.log(fileInfo);
    client.sendDocumentUpload(fileInfo);

}


//监听文档更新
function docUpdate(callbackData){

    console.log("监听文档更新=========================>");
    console.log(callbackData);
    if(callbackData==null){
        return;
    }
    if (callbackData.visible===true){
        showInter(callbackData,2);
    }
    //操作数据
    updateDocList(callbackData,0);



}
//显示模块
function showInter(_data,isPage){
    console.log("showInter==============>")
    if (isPage===2){
        console.log("当前文档",_data);
        console.log("此时fileFromArr数组是",fileFromArr);
        console.log("当前文档类型",_data.fileType);


        if(_data.fileType=="doc"||_data.fileType=="pdf"){

            $("#showImg").css("display","none");
            $(".docImage").css("display","block");
            $(".canvas_container").css("overflow-y","scroll");
        var _fileType="jpg";
        var _paramInfo={
            "type": _fileType,
            // "curPageNo":_data.curPageNo,
            "pageNum":_data.pageNum,
            "relativeUrl": _data.relativeUrl
        };
        docfullPath=client.getDocImageFullPath(_paramInfo);
        // console.log("mcu返回给我的地址==========");
        // console.log(docfullPath);

        // imgUrl = docfullPath[0];
        // $("#docImage").css("display","block");



        var curPageNum =_data.curPageNo;
        var pageNum=_data.pageNum;
        $("#curPageNum").html(curPageNum);
        $("#totalPageNum").html(pageNum);
        for (var i=0;i<=docfullPath.length;i++){
            var docfullSingle=docfullPath[curPageNum-1];
            $("#docImage").attr("src",docfullSingle);
        }


            //点击下一页
            $("#nextPage").on("click",function (e) {

                if (curPageNum!==pageNum){
                    for (var i=0;i<=docfullPath.length;i++){
                        var docfullSingle=docfullPath[curPageNum];
                        console.log("curPageNum,docfullSingle",curPageNum,docfullSingle);
                        $("#docImage").attr("src",docfullSingle);
                    }
                    curPageNum++;
                }

                var paramInfo={
                    "itemIdx": _data.itemIdx,
                    "curPageNo":curPageNum
                };
                console.log("paramInfo=======>",paramInfo)
                client.sendDocumentSwitchPage(paramInfo);

                $("#curPageNum").html(curPageNum);


            });

            //点击上一页

            $("#prevPage").on("click",function (e) {
                if (curPageNum>1){
                    curPageNum--;
                    console.log("curPageNum",curPageNum);
                    for (var i=0;i<=docfullPath.length;i++){
                        var docfullSingle=docfullPath[curPageNum-1];
                        console.log("curPageNum,docfullSingle",curPageNum,docfullSingle);
                        $("#docImage").attr("src",docfullSingle);


                   }

                }
                var paramInfo={
                    "itemIdx": _data.itemIdx,
                    "curPageNo":curPageNum
                };
                client.sendDocumentSwitchPage(paramInfo);
                $("#curPageNum").html(curPageNum);

            });



            if (classAllInfo.userRole=="normal"){
                $(".next-page ").css("display","none");
                $(".total-page").css("display","none");
                $(".bias").css("display","none");
                $(".cur-page").css("display","none");
                $(".prev").css("display","none");

            }else{
                showTurnPage();
            }




        }
    else if(_data.fileType=="jpg"){
            $("#canvas").height(476);

            $(".docImage").css("display","none");
            $("#showImg").css("display","block");
            $(".canvas_container").css("overflow","hidden");


            var _fileType="jpg";
            var _paramInfo={
                "type": _fileType,
                "pageNum":_data.pageNum,
                "relativeUrl": _data.relativeUrl
            };
            docfullPath=client.getDocImageFullPath(_paramInfo);

            console.log("mcu返回给我的地址==========");
            console.log(docfullPath);
            imgUrl = docfullPath[0];
            $("#showImg").css("display","block");
            $("#showImg").attr("src",imgUrl);





        }
        else if(_data.fileType=="png"){
            $("#canvas").height(476);
            $(".docImage").css("display","none");
            $("#showImg").css("display","block");
            $(".canvas_container").css("overflow","hidden");
            var _fileType="png";
            var _paramInfo={
                "type": _fileType,
                "curPageNo":_data.curPageNo,
                "pageNum":_data.pageNum,
                "relativeUrl": _data.relativeUrl
            };
            docfullPath=client.getDocImageFullPath(_paramInfo);

            console.log("mcu返回给我的地址==========");
            console.log(docfullPath);
            imgUrl = docfullPath[0];
            $("#showImg").css("display","block");
            $("#showImg").attr("src",imgUrl)
            $("#docCanvas").css("display","none");


        }


    }

}




function showTurnPage() {
    $(".next-page ").css("display","block");
    $(".total-page").css("display","block");
    $(".bias").css("display","block");
    $(".cur-page").css("display","block");
    $(".prev").css("display","block");

}


//翻页模块
function turnPage(_data){
    console.log("翻页模块")
    console.log(_data);
    var curPageNum =_data.curPageNo;
    var pageNum=_data.pageNum;

    $("#curPageNum").html(curPageNum);
    $("#totalPageNum").html(pageNum);


    //点击下一页
    $("#nextPage").on("click",function (e) {
        if (curPageNum<pageNum){
            curPageNum++;

        }
        var paramInfo={
            "itemIdx": _data.itemIdx,
            "curPageNo":curPageNum
        };
        client.sendDocumentSwitchPage(paramInfo);

        $("#curPageNum").html(curPageNum);
        // openPage(pdf, curPageNum);

    });

    //点击上一页

    $("#prevPage").on("click",function (e) {
        if (curPageNum>1){
            curPageNum--;
        }
        var paramInfo={
            "itemIdx": _data.itemIdx,
            "curPageNo":curPageNum
        };
        client.sendDocumentSwitchPage(paramInfo);

        $("#curPageNum").html(curPageNum);
        // openPage(pdf, curPageNum);


    });

}

//监听文档删除
function docDelete(callbackData){
    console.log("监听文档删除");
    console.log(callbackData);
    //
    updateDocList(callbackData,1);

    //操作页面
    $("li").remove(".xin");

}


//专门操作数据
function updateDocList(_data,isAdd) {
    var index;
    console.log("isAdd的值是",isAdd);
    //isAdd  为0,进行更新;为1,进行删除
    if(isAdd===0){
        index=getDocIndexInList(_data);
        console.log(index);
        if(index>=0){
            fileFromArr[index]=_data;
        }else {
            fileFromArr.push(_data);
            showFile(fileFromArr);

        }

    }else if(isAdd===1) {
        console.log("对数据进行删除");
        for (var i=0;i<fileFromArr.length;i++){
            console.log(fileFromArr);
            if (fileFromArr[i].itemIdx==_data){
            fileFromArr.splice(i,1);
            }
        }
        if(fileFromArr.length==0){
            console.log(fileFromArr);
            $("#docCanvas").css("display","none");
            $("#showImg").css("display","none");
            showTurnPage();
        }
    }
}

//专门循环数组
function getDocIndexInList(_param){
    var len=fileFromArr.length;
    var docItem;
    for(var i=0;i<len;i++){
        docItem=fileFromArr[i];
        if(_param.itemIdx==docItem.itemIdx){
            return i;
        }
    }
    return -1;
}



//进入课堂失败
function classFailed(callbackData) {
    console.log("classFailed---课堂失败");
    console.log(callbackData);

    var code=callbackData.code;
    switch(code) {
        case 100:
            //当前没有 课堂号   用户角色  ip
            if((classLoadInfo.classId)==""||classLoadInfo.userRole==""||(classLoadInfo.portal)==":"||(classLoadInfo.portalPort)==""||(classLoadInfo.portalIP)==""||(classLoadInfo.userName)==""||(classLoadInfo.userType=="")){
                console.log("不会执行clientInit");

                //用户进行角色选择
                showUserSelect();

            }
           console.log("初始化失败,课堂号不存在/错误");

            break;

        case 101:
        case 102:
            console.log("初始化协议错误");
            $(".loading-index").css("display","none");
            showUserSelect();break;
        case 103:
            
            //初始化错误
            //1.userRole为空,回到选择角色界面
            if (classLoadInfo.userRole==""){
                console.log("当前没有选择用户角色");
                //进行用户选择页面
                showUserSelect();

            }
            //2.userType为空,回到选择角色界面
            if (classLoadInfo.userType==""){
                console.log("当前没有选择用户角色");
                //进行用户选择页面
                showUserSelect();
            }

            //3.classId为空,回到选择角色界面
            if(classLoadInfo.classId===0){
                console.log("classId不正确");
                //输入课堂号页面
                showParmasInput()

            }
            //4.portal不正确且角色身份为空
            if(((classLoadInfo.portal==":")&&(classLoadInfo.userRole=="0"))||((classLoadInfo.portal==":")&&(classLoadInfo.userType=="1"))){
                console.log("portal不正确");
                //进行用户选择页面
                showUserSelect();

            }
            break;
        case 105:
            console.log(classLoadInfo.classId);
            console.log("初始化失败,课堂号不存在/错误");


            //如果课堂号错误,但是身份正确,只进入输入课堂号页面
            if (classLoadInfo.userRole=="host"||classLoadInfo.userRole=="normal"||classLoadInfo.userType=="1"){
                $(".loading-index").css("display","none");
                showParmasInput();
            }
            //否则,选择角色
            else{
                $(".loading-index").css("display","none");
                showUserSelect();
            }

            break;
        case 200:break;
        case 203:break;
        case 204:break;
        case 205:break;
        case 206:classPwdErrorTip(); break;
        case 207:break;
        case 300:break;
        case 301:break;
        default:break;
    }


}

//课堂密码错误  进行提示
function classPwdErrorTip() {
    $(".passWordTip").css("margin-left","45px");
    $(".passWordTip")[0].innerHTML="请输入正确的课堂密码";
}
//显示用户的选择页面
function showUserSelect() {
    $(".fourParamsOut").css("display","block");
    $(".permission").css("display","block");
    $(".fourParams").css("display","none");
    $(".loginBg").css("display","none");

    $("#btn-per").click(function (e) {

        if((classLoadInfo.userRole==="host")||(classLoadInfo.userRole==="normal")){
            showParmasInput();

        }
        else if ((classLoadInfo.userType!==1)||(classLoadInfo.userType===8)){
            showParmasInput();

        }
        else if(classLoadInfo.userRole=="0") {
            console.log(classLoadInfo.userRole);
            console.log(classLoadInfo.userType);
            console.log("请选择角色-----");
        }
        console.log(classLoadInfo.userRole);
        console.log(classLoadInfo.userType);
    });

}


//显示相应的登录页面
function showLogin(isShow){

    $(".fourParamsOut").css("display","none");
    //loading加载页隐藏
    $(".loading-index").css("display","none");
    $(".fourParams").css("display","none");
    //主页面隐藏
    $(".box").css({
        "display":"none",
        "margin":"0 auto"
    });

    if (isShow) {
        //登录页面显示(有密码)
        $(".loginBg ").css("display","block");
        console.log("loginBgblock");
        $(".userNameInput").focus(function () {
            $(".userTip").css("margin-left","0");
            $(".userTip")[0].innerHTML="支持中文、字母、数字、“-”“_”的组合，4-20个字符";
        });
        $(".userNameInput").blur(function () {
            var val = this.value.replace(/^ +| +$/g,"");
            if (val.length === 0) {
                $(".userTip").css("margin-left","45px");
                $(".userTip")[0].innerHTML="用户名不能为空";
                return false;
            }

            var reg = /^([\u4e00-\u9fa5]{2,4})|([A-Za-z0-9_\-]{4,20})$/;
            if (!reg.test(val)) {
                $(".userTip").css("margin-left","45px");
                $(".userTip")[0].innerHTML = "长度只能在4-20个字符之间";
                return false;
            }else{
                $(".userTip")[0].innerHTML = "";
            }
        })

        $(".passWordInput").focus(function () {
            $(".passWordTip").css("margin-left","45px");
          $(".passWordTip")[0 ].innerHTML="请输入正确的课堂密码";
        });
        $(".passWordInput").blur(function () {
            $(".passWordTip")[0].innerHTML="请输入课堂密码";
        })
        $("#btnLogin").click(function (e) {

            console.log("点击了登录按钮---------->");
            var userName = $(".userNameInput").val();
            var pwd = $(".passWordInput").val();

            if (!userName) {
                $(".userTip").css("margin-left","45px");

                $(".userTip")[0].innerHTML="用户名不能为空";

             }
             if (!pwd) {
                $(".passWordTip").css("margin-left","45px");
                $(".passWordTip")[0].innerHTML="课堂密码不能为空";
            }
            if($(".passWordInput").val().length>=1){
                $(".passWordTip")[0].innerHTML="";
            }
            if (($('.userNameInput').val().length>=4) &&($(".passWordInput").val().length>=1)) {

                onJoinClass(userName, pwd);
            }
        });

    }else{
        //登录页面显示(无密码)
        $(".loginBg ").css("display","block");
        $(".passWordLi").css("display", "none");
        $(".btnLoginLi").css("margin-top","30px");

        console.log("无密码");
        $(".userNameInput").focus(function () {
            $(".userTip").css("margin-left","0");
            $(".userTip")[0].innerHTML="支持中文、字母、数字、“-”“_”的组合，4-20个字符";
        });
        $(".userNameInput").blur(function () {
            var val = this.value.replace(/^ +| +$/g,"");
            if (val.length === 0) {
                $(".userTip").css("margin-left","45px");
                $(".userTip")[0].innerHTML="用户名不能为空";
                return false;
            }

            var reg = /^([\u4e00-\u9fa5]{2,4})|([A-Za-z0-9_\-]{4,20})$/;
            if (!reg.test(val)) {
                $(".userTip").css("margin-left","45px");
                $(".userTip")[0].innerHTML = "长度只能在4-20个字符之间";
                return false;
            }else{
                $(".userTip")[0].innerHTML = "";
            }
        })


        $("#btnLogin").click(function (e) {
            console.log("点击了登录按钮---------->");
            var userName = $(".userNameInput").val();
            var pwd = $(".passWordInput").val();
            if ($(".userNameInput").length) {
                if (!userName) {
                    $(".userTip").css("margin-left","45px");
                    $(".userTip")[0].innerHTML="用户名不能为空";
                }
            }
            if($('.userNameInput').val().length>=4){
            onJoinClass(userName);
            }
        });
    }



}

//用户角色的选择
function getValue(msg) {

    if(msg=="host"){
        classLoadInfo.userType=parseInt("8");
    }else if (msg=="normal"){
        classLoadInfo.userType=parseInt("1");
    }else{
        classLoadInfo.userType=parseInt("1");
    }
    console.log("拿到的用户角色");
    console.log(msg);
    classLoadInfo.userRole = msg;
}



//加入课堂初始化失败时,自己输入课堂号参数
function showParmasInput(){
    var classId;
    $(".fourParamsOut").css("display","block");
    $(".permission").css("display","none");
    $(".fourParams").css("display","block");
    $(".loginBg").css("display","none");
    if(classLoadInfo.classId){
        console.log("有课堂号");
        console.log(classLoadInfo.classId);
        $(".classId")[0].value=classLoadInfo.classId;
    }else if(classLoadInfo.userId){
        console.log(classLoadInfo.userId);
        $(".userId")[0].value=classLoadInfo.userId;
    }

    $("#btnFourParam").click(function (e) {

     var classId = parseInt($(".classId").val());
    // let userRole = $(".userRole").val();
    // let portal = $(".portal").val();
    var userId = $(".userId").val();

    // var fourParams={};

    fourParams={

        classId:classId,
        userRole:classLoadInfo.userRole,
        portal:"112.126.80.182:90",
        userId:userId
    }
    console.log("当前参数");
    console.log(fourParams);

        client.init(fourParams,classInitSuccess,classFailed);
    });


}


//加入课堂成功
function classJoinSuccess(callbackData){

    console.log("classJoinSuccess",callbackData);
    console.log(callbackData);

   //根据用户权限,隐藏不同界面,如果是学生,隐藏白板
if (callbackData.userRole=="normal"){

    $("#tool").css("display","none");
    $(".fileUpload").css("display","none");
    $(".am-dropdown").css("display","none");
    $("#stuVideo-video").css("display","none");
    $("#stuVideo-voice").css("display","none");
    $("#teacherVideo-video").css("display","none");
    $("#teacherVideo-voice").css("display","none");


}



    classAllInfo=callbackData;

    //准备主页面
    layoutView();
    //开始课堂
    startClass();
}

//开始课堂
function startClass() {
    if(client){

        //监听到聊天信息
        client.on(MessageTypes.CHAT_RECEIVE,chatReceive);


        client.on(MessageTypes.WHITEBOARD_ANNOTATION_UPDATE,whiteboardUpdate);//监听白板更新

        client.on(MessageTypes.DOC_DELETE,docDelete);//监听删除文档
        client.on(MessageTypes.DOC_UPDATE,docUpdate);//监听更新文档




    }
}

//登录成功后,登录页隐藏,主页面显示
function layoutView( ) {

    console.log("123000000000000000000000000000000000000");
    //输入4个参数的页面隐藏
    $(".fourParamsOut").css("display","none");
    //登录成功后,登录页隐藏
    $(".loginBg ").css("display","none");
    $(".box").css({
        "display":"block"
    });

    // if(_type==1){
    //     //主页面显示
    //     $(".box").css({
    //         "display":"block"
    //     });
    //     $(".zbbox").css({
    //         "display":"none"
    //     });
    //
    //
    // }else{
    //     $(".box").css({
    //         "display":"none"
    //     });
    //     $(".zbbox").css({
    //         "display":"block"
    //     });
    //
    // }






    //
    // //老师的视频区域
    // var teaVideo = document.getElementById("teacherVideo-video");
    // var teaVv = document.getElementById("teacherVideo-voice");
    // var closeVideo = document.getElementById("close-video");
    // var closeVoice = document.getElementById("close-voice");
    //
    // var throbberLoader1 = document.getElementById("throbber-loader1");
    // var throbberLoader2 = document.getElementById("throbber-loader2");
    // var throbberLoader3 = document.getElementById("throbber-loader3");
    // var throbberLoader4 = document.getElementById("throbber-loader4");
    // var throbberLoader5 = document.getElementById("throbber-loader5");
    // var throbberLoader6 = document.getElementById("throbber-loader6");
    //
    //
    // //老师点击麦克按钮
    // var showflag = 0;
    // teaVv.onclick = function () {
    //     if (showflag == "0") {
    //         closeVoice.style.display = "none";
    //         showflag++;
    //         console.log(showflag);
    //
    //         throbberLoader1.className = "throbber-loader1";
    //         throbberLoader2.className = "throbber-loader2";
    //         throbberLoader3.className = "throbber-loader3";
    //         throbberLoader4.className = "throbber-loader4";
    //         throbberLoader5.className = "throbber-loader5";
    //         throbberLoader6.className = "throbber-loader6";
    //         $(".teacherVideoBg").css("display","none");
    //
    //     } else if (showflag == "1") {
    //         closeVoice.style.display = "block";
    //         showflag--;
    //         console.log(showflag);
    //         throbberLoader1.className = "teacherVideo-voice-progress-span-1";
    //         throbberLoader2.className = "teacherVideo-voice-progress-span-2";
    //         throbberLoader3.className = "teacherVideo-voice-progress-span-3";
    //         throbberLoader4.className = "teacherVideo-voice-progress-span-4";
    //         throbberLoader5.className = "teacherVideo-voice-progress-span-5";
    //         throbberLoader6.className = "teacherVideo-voice-progress-span-6";
    //         $(".teacherVideoBg").css("display","block");
    //     }
    // }
    //
    // //老师点击视频按钮
    // var Videoflag = 0;
    // teaVideo.onclick = function () {
    //     console.log(navigator.mediaDevices);
    //     navigator.mediaDevices = navigator.mediaDevices || ((navigator.mozGetUserMedia || navigator.webkitGetUserMedia) ? {
    //                 getUserMedia: function (c) {
    //                     return new Promise(function (y, n) {
    //                         (navigator.mozGetUserMedia ||
    //                         navigator.webkitGetUserMedia).call(navigator, c, y, n);
    //                     });
    //                 }
    //             } : null);
    //     console.log(navigator.mediaDevices);
    //     if (Videoflag == "0") {
    //         closeVideo.style.display = "none";
    //         closeVoice.style.display = "none";
    //         Videoflag++;
    //         throbberLoader1.className = "throbber-loader1";
    //         throbberLoader2.className = "throbber-loader2";
    //         throbberLoader3.className = "throbber-loader3";
    //         throbberLoader4.className = "throbber-loader4";
    //         throbberLoader5.className = "throbber-loader5";
    //         throbberLoader6.className = "throbber-loader6";
    //
    //         var constraints = {audio: true, video: true};
    //
    //         navigator.mediaDevices.getUserMedia(constraints)
    //             .then(function (stream) {
    //                     if (window.URL) {
    //                         console.log(window.URL);
    //                         var newSrc = window.URL.createObjectURL(stream);
    //                         //将老师流地址给老师的Video
    //                         $("#teacherVideoInfo").attr("src",newSrc);
    //                     } else {
    //                         $("#teacherVideoInfo").src = stream;
    //                     }
    //                     $(".teacherVideoInfo").autoplay = true;
    //
    //                     var videoName=stream.getVideoTracks()[0].label;
    //                     var audioName=stream.getAudioTracks()[0].label;
    //                     console.log(videoName);
    //                     console.log(audioName);
    //
    //                 }
    //             )
    //             .catch(function (err) {
    //                 console.log(err.name + ": " + err.message);
    //             });
    //
    //
    //
    //         $(".teacherVideoBg").css("display","none");
    //     } else if (Videoflag == "1") {
    //         closeVideo.style.display = "block";
    //         closeVoice.style.display = "block";
    //         Videoflag--;
    //         throbberLoader1.className = "teacherVideo-voice-progress-span-1";
    //         throbberLoader2.className = "teacherVideo-voice-progress-span-2";
    //         throbberLoader3.className = "teacherVideo-voice-progress-span-3";
    //         throbberLoader4.className = "teacherVideo-voice-progress-span-4";
    //         throbberLoader5.className = "teacherVideo-voice-progress-span-5";
    //         throbberLoader6.className = "teacherVideo-voice-progress-span-6";
    //
    //         $(".teacherVideoBg").css("display","block");
    //         $("#teacherVideoInfo").attr("src","");
    //     }
    //
    // }


    //发送聊天消息
    $("#btn_send").click(function (e) {
        console.log("点击了发送消息按钮------->");
        sendChatMsg();

    });

    // 文件上传

    $("#pushFile").click(function () {
        $("#file").click();
    });


    // //视频按钮点击
    // $("#teacherVideo-video").click(function (e) {
    //     console.log("teacherVideo-video点击");
    //     $("#teacherVideo-video").html(" ");
    //     $("#teacherVideo-video").removeClass("teacherVideo-video");
    //     $("#teacherVideo-video").addClass("teacherVideo-videoBg");
    //
    //
    //     $("#teacherVideo-voice").html("&#xe62d;");
    //     $("#teacherVideo-voice").addClass("teacherVideo-voice");
    //     $("#teacherVideo-voice").removeClass("teacherVideo-voiceBg");
    //
    //
    //     //获取推流地址
    //     achieveStream();


    // });

//音频按钮点击
    $("#teacherVideo-voice").click(function (e) {

        console.log("teacherVideo-voice点击");
        $("#teacherVideo-video").html("&#xe62e;");
        $("#teacherVideo-video").removeClass("teacherVideo-videoBg");
        $("#teacherVideo-video").addClass("teacherVideo-video");

        $("#teacherVideo-voice").html("");
        $("#teacherVideo-voice").removeClass("teacherVideo-voice");
        $("#teacherVideo-voice").addClass("teacherVideo-voiceBg");
    });

}
function whiteboardUpdate(callbackData) {

    console.log("同步canvas消息===========================");
    console.log(callbackData);

    draw.drawCanvas(callbackData);
    // canvasInfoUpdate=callbackData;
    //
    // // canvasInfoUpArr.push(canvasInfoUpdate.itemIdx);
    //
    // console.log("同步的存到数组中");
    // console.log(canvasInfoUpArr);
    //
    // draw.ss(canvasInfoUpdate);
    // draw.trans(canvasInfoUpArr);
}
function whiteboardDelete(callbackData) {
    console.log("监听白板删除的消息============================");
    console.log(callbackData);
    draw.clearContextCan();
    canvasInfoUpArr=[];
    canvasInfoArr=[];

}

//接收聊天消息
function chatReceive(callbackData){
    console.log()

    console.log("777777777777777777777777777777");
    console.log(callbackData);
    var tpl = callbackData.fromRole == "host"? tpl_message_teacher : tpl_message_student;
    var message = (callbackData.message + "").replace(/\[img:([^\[:\]]*)\]/ig, function (match, group, index) {
        return '<img src="images/face/' + group + '.gif"/>';
    });

    var strHTML = format(tpl, {
        name: callbackData.fromName,
        message: message
    });

    $("#panel_message").append(strHTML);
    $("#panel_message")[0].scrollTop=$("#panel_message")[0].scrollHeight;



}



//将地址转化成一个对象
function GetUrlParam() {
    var url = location.search;
    var thisParam = new Object();
    // 判断是否存在请求的参数
    if (url.indexOf("?") != -1) {
        var str = url.substr(1);
        // 截取所有请求的参数，以数组方式保存
        strs = str.split("&");
        for (var i = 0; i < strs.length; i++) {
            // 获取该参数名称，值。其中值以unescape()方法解码，有些参数会加密
            thisParam[strs[i].split("=")[0]] = unescape(strs[i].split("=")[1]);
        }
    }
    console.log(thisParam);
    // 返回改参数列表对象
    return thisParam;
}

//将用户名和密码提交给底层
function onJoinClass(userName, password) {
    //加入课堂的信息
    var classInfo = {};
    if (classInfo) {
        classInfo.userName = userName;
        classInfo.password = password;
         client.joinClass(classInfo,classJoinSuccess);
    } else {
        console.log("error");
        return false;

    }

}

//发送聊天消息
function sendChatMsg() {
    var message = $("#txt_message").val();
    var messageInfo={
        "to":0,
        "message":message
    };
    if (!message)
        return;
    else {
        $("#txt_message").val("");

        client.sendChatMsg(messageInfo);
    }
}

function loading() {

    $(".box").css({
        "display":"none",
        "margin":"0 auto"
    });
    $(".loading-index").css("display","block");
    $(".fourParamsOut").css("display","none");
    $(".permission").css("display","none");
    $(".fourParams").css("display","none");
    $(".loginBg").css("display","none");


}
//在页面loading时,提交验证,传给底层
function urlParamsJudge(){
    //1.地址栏获取参数
     classLoadInfo=getURLParams();
    //client.init({"classId":1997848892,"portal":"112.126.80.182:80","userRole":"normal","userId":"0"},classInitSuccess,classJoinFailed);
    console.log("显示地址栏的数据");
    console.log(classLoadInfo);

    classParamInfo.classId=classLoadInfo.classId;       //(必选) 课堂号.
    classParamInfo.portal=classLoadInfo.portal;         //(必选) ip地址
    classParamInfo.userRole=classLoadInfo.userRole;    //用户的身份
    classParamInfo.userId=classLoadInfo.userId;        //第三方用户id
    classParamInfo.userType=classLoadInfo.userType;     //用户的身份  默认1
    classParamInfo.userName=classLoadInfo.userName;     //第三方用户名称
    console.log("传给底层,进行初始化的数据");
    console.log(classParamInfo);
    clientInit(classParamInfo);

}
//进行初始化
function clientInit(_classLoadInfo) {

    console.log("初始化的信息");
    console.log(_classLoadInfo)
    client.init(_classLoadInfo,classInitSuccess,classFailed);
}

//从地址栏拿到classId,userRole,portal,userId
function  getURLParams(){
    var classUrlParam=GetUrlParam();
    console.log(classUrlParam);
    var classLoadInfo = {};
    classLoadInfo.classId=parseInt(classUrlParam.classId)||0;
    classLoadInfo.userRole=classUrlParam.userRole||"0";
    classLoadInfo.portalIP=classUrlParam.portalIP||"";
    classLoadInfo.portalPort=classUrlParam.portalPort||"";
    classLoadInfo.userName=classUrlParam.userName||"";
    classLoadInfo.userType=parseInt(classUrlParam.userType)||1;
    classLoadInfo.userId=classUrlParam.userId?classUrlParam.userId:"0";
    classLoadInfo.portal=classLoadInfo.portalIP+":"+classLoadInfo.portalPort;
    console.log(classLoadInfo);
    return classLoadInfo;
}

//工具类
function format(str, obj) {
    return str.replace(/\{(\w+)\}/g, function (match, group, index) {
        return obj[group];
    });
}




// //获取推流地址
// function achieveStream(){
//
//     var paramInfo={
//         "type": "flash"
//     };
//     var result=client.getVideoPublishPath(paramInfo);
//
//     console.log("执行getPublishVideoPath,返回的结果")
//     console.log(result);
//
// };